import { Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Form, Select, SelectTree, TextInput, TreeGridEditable } from '@zeedhi/common';
import { ZdFileInput, ZdTextInput, ZdTabs } from '@zeedhi/vuetify';

export class InstanceService {
	public static getInstanceTekGrid(name: string): TekGrid {
		return Metadata.getInstance<TekGrid>(name);
	}

	public static getInstanceZdForm(name: string): Form {
		return Metadata.getInstance<Form>(name);
	}

	public static getInstanceZdTextInput(name: string): ZdTextInput {
		return Metadata.getInstance<ZdTextInput>(name);
	}

	public static getInstanceTextInput(name: string): TextInput {
		return Metadata.getInstance<TextInput>(name);
	}

	public static getInstanceZdSelect(name: string): Select {
		return Metadata.getInstance<Select>(name);
	}

	public static getInstanceSelectTree(name: string): SelectTree {
		return Metadata.getInstance<SelectTree>(name);
	}

	public static getInstanceZdFileInput(name: string): ZdFileInput {
		return Metadata.getInstance<ZdFileInput>(name);
	}

	public static getInstanceTreeGridEditable(name: string): TreeGridEditable {
		return Metadata.getInstance<TreeGridEditable>(name);
	}

	public static getInstanceTabs(name: string): ZdTabs {
		return Metadata.getInstance<ZdTabs>(name);
	}

	public checkIfSelectIsSelected(name: string) {
		try {
			const select = Metadata.getInstance<Select>(name);
			return !!Object.keys(select.selectedData).length;
		} catch (error) {
			return false;
		}
	}
}
